unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, StdCtrls, DateUtils;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Timer1: TTimer;
    Timer2: TTimer;
    StatusBar1: TStatusBar;
    Edit1: TEdit;
    Edit2: TEdit;
    Memo2: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { Private declarations }
    StartTime : TDateTime;
    NowLine : Integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Memo2.Lines.Clear;
  StartTime := Now;
  NowLine := 0;
  Timer1.Enabled := True;
  Timer2.OnTimer(Timer2);
  Timer2.Enabled := True;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  StatusBar1.SimpleText := FormatDateTime('HH:mm:ss',Now - StartTime)
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var
  o1,o2,o3,n1,n2,n3 : Int64;
  NewTime,OldTime : Int64;
  TimerInterval : Int64;
begin
  try
    n1 := StrToInt(Copy(Memo1.Lines.Strings[NowLine],2,2)) * 60 * 1000;
    n2 := StrToInt(Copy(Memo1.Lines.Strings[NowLine],5,2)) * 1000;
    n3 := StrToInt(Copy(Memo1.Lines.Strings[NowLine],8,2)) * 10;
    NewTime := n1 + n2 + n3;
    TimerInterval := NewTime - MilliSecondsBetween(StartTime,Now);
  except
    TimerInterval := 5000;
  end;
  Timer2.Interval := TimerInterval;
  if NowLine = 0 then
    Edit1.Text := ''
  else
    begin
      Edit1.Text := Memo1.Lines.Strings[NowLine - 1];
      Memo2.Lines.Add(IntToStr(MilliSecondsBetween(StartTime,Now)));
    end;
  Inc(NowLine);
  if NowLine > Memo1.Lines.Count + 1 then
    begin
      Timer1.Enabled := False;
      Timer2.Enabled := False;
    end;
end;

end.
